<script lang="ts">
  import '../../app.scss';
  import NavBar from '@components/NavBar.svelte';
  import Notifications from 'svelte-notifications';
  import oidc from '@auth/keycloak'
  import { Gql } from '@db';
  import Env from '@env';
  import { Alert } from '@sveltestrap/sveltestrap';

  let displayHelp = false;

  async function initializeAuth() {
    setTimeout(() => (displayHelp = true), 5000);
    // Initialize Keycloak
    await oidc.initialize()
    // Initialize GraphQL Client, which subscribes to keycloak
    Gql.initialize();
  }
</script>

<div>
  {#if Env.IntercomWarning}
    <Alert class="m-2" color="warning">{Env.IntercomWarning}</Alert>
  {/if}
  {#if Env.IntercomError}
    <Alert class="m-2" color="danger">{Env.IntercomError}</Alert>
  {/if}
</div>
{#await initializeAuth()}
  <div class="d-flex h-100 align-items-center justify-content-center">
    <div>
      <h1>Loading...</h1>
      {#if displayHelp}
        <p>This is taking longer than expected. Please reach out to the scoreboard administrator.</p>
        <pre>{JSON.stringify(Env, null, 2)}</pre>
      {/if}
    </div>
  </div>
{:then _}
  <div class="min-vh-100" >
    <NavBar />

    <Notifications zIndex="1200">
      <slot />
    </Notifications>
  </div>
{:catch e}
  <div class="d-flex align-items-center min-vh-100 flex-wrap w-100">
    <div class="mx-auto">
      <p>Uh oh! We've had a major hiccup, and it looks like the site is down.</p>
      <p>
        Please report this to us in Discord or at
        <a href="mailto:support@c2games.org">support@c2games.org</a>
      </p>
      {#if e?.stack}
        <p class="p-1">Please Include the following information:</p>
        <pre>
          {e.stack}
        </pre>
      {/if}
    </div>
  </div>
{/await}
